<template>
    <div :class="[
        'sidebar-block',
        { collapsable: collapsable },
        { collapsed: collapsed}
    ]">
        <div
            class="sidebar-title"
            @click.prevent="collapse"
        >
            {{ title }}
        </div>

        <horizontal-loader v-if="loading" />

        <slide-up-down
            v-if="!loading"
            :active="!collapsed"
            :duration="300"
            class="sidebar-content"
        >
            <div class="sidebar-leagueslist">
                <div v-for="(item, idx) in items" :key="idx" class="item item-country">
                    <div class="country-info" :class="`country-info-${idx}`" @click.prevent="toggleCountryLeagues(idx)">
                        <div
                            class="icon"
                            :class="`icon-flag flag-icon flag-icon-${item.iso_2 && item.iso_2.length ? item.iso_2.toLowerCase() : 'placeholder'}`"
                        ></div>
                        <div class="text">{{ item.name }}</div>
                    </div>
                    <div
                        class="country-leagues"
                        :class="[
                            `country-leagues-${idx}`,
                            {
                                active: openedStates[idx]
                            }
                        ]"
                        v-if="item.leagues && item.leagues.length"
                    >
                        <router-link
                            :to="`/football/league/${league.id}`"
                            class="item item-league flex aic"
                            v-for="league in item.leagues"
                            :key="league.id"
                            @click.native="scrollToTop"
                        >
                            <div
                                class="league-logo "
                                :style="{
                                    'backgroundImage': `url('${league.img ? '/storage/' + league.img : '../../img/league_placeholder.svg'}')`
                                }"
                            ></div>
                            <span class="name">{{ league.name }}</span>
                        </router-link>
                    </div>
                </div>
            </div>
        </slide-up-down>
    </div>
</template>

<script>
import SlideUpDown from 'vue-slide-up-down'
import HorizontalLoader from '../HorizontalLoader'
export default {
    name: 'Leagues',
    props: {
        title: String,
        collapsable: Boolean,
        items: Array,
        loading: Boolean
    },
    data() {
        return {
            collapsed: false,
            openedStates: {}
        }
    },
    methods: {
        collapse() {
            this.collapsed = !this.collapsed
        },
        toggleCountryLeagues(idx) {
            this.openedStates[idx] = !this.openedStates[idx]
            this.$forceUpdate()
        },
        scrollToTop() {
            window.scrollTo(0,0);
        }
    },
    watch: {
        items(items) {
            items.map((country, idx) => {
                this.openedStates[idx] = false
            })
        }
    },
    mounted() {
        this.items.map((country, idx) => {
            this.openedStates[idx] = false
        })
    },
    components: { HorizontalLoader, SlideUpDown }
}
</script>

<style scoped lang="scss">
    .sidebar-content {
        /*max-height: 300px;*/
        /*overflow: auto;*/
        .item.item-country {
            cursor: pointer;
            flex-wrap: wrap;
            .country-info {
                width: 100%;
                display: flex;
                align-items: center;
            }
            .country-leagues {
                padding: 12px 0 12px 20px;
                transition: .3s ease;
                max-height: 1000px;
                overflow: hidden;
                &:not(.active) {
                    max-height: 0px;
                    padding: 0 0 0 20px;
                }
            }
            .league-logo {
                width: 16px;
                min-width: 16px;
                height: 16px;
                background-size: contain;
                background-position: 50%;
                background-repeat: no-repeat;
                margin-right: 6px;
                position: relative;
                &:after{
                    content: "";
                    position: absolute;
                    background: rgba(255,255,255,0.5);
                    border-radius: 3px;
                    width: 14px;
                    height: 13px;
                    left: 0;
                    top: 0;
                    z-index: -1;
                    filter: blur(4px);
                }
            }
            .item-league {
                width: 100%;
                text-decoration: none;
            }
        }
    }

    .sidebar-content::-webkit-scrollbar {
        width: 10px;
    }

    .sidebar-content::-webkit-scrollbar-track {
        background: linear-gradient(270deg, #252D33 0%, #2F3840 100%);
    }

    .sidebar-content::-webkit-scrollbar-thumb {
        background: linear-gradient(90deg, #343D46 0%, #424B54 100%);
        border-radius: 3px;
    }

    .sidebar-content::-webkit-scrollbar-thumb:hover {
        background: linear-gradient(90deg, #343D46 0%, #424B54 100%);
    }
</style>
